#!/usr/bin/perl

##############################################################
#
#	Display.cgi for Database_Doctor.cgi
#	Mike Carville
#	www.web-bazaar.com
#	carville@web-bazaar.com
#
# 	This script is made available free of charge.
# 	Please leave my name in the header section.
# 	You may not sell this script for any reason.
#	While not required, please leave the banner in the footer
#	in the manager script to help fund further development.
#
#	If you are really thrilled with this script, why not help 
#	us both out and buy a reference book from our scripts page.
#	We get a commission, you get knowledge, and Amazon stockholders
#	breathe easier for another day. <:-)
#
#	I originally wrote the Database Doctor to manage inventory files for webstores,
#	specifically Selena Sols. But since everyone has an imagination and is generally 
#	looking for the best fit of something existing to a custom project, people 
#	were constantly asking for a front end.  
#	
#	Ok, so now you have it.
#	
#	Display.cgi will display your flat file database made in Database Doctor,
#	or just about any I suppose. I believe I have given you a way to be really 
#	creative with the html as well. You be the judge, As always, to make something 
#	better, it gets more complicated.
#	
#	After we discuss the file setup here, read below, as there more comments placed
#	to help you use this to it's fullest.
#	
#	The working example of what I am using this for is at www.fsfprs.com
#	A database of Facial Plastic Surgeons.
#	
#	Main CGI Directory
#	--------------
#	display.cgi (permission 755)
#	
#	Data
#	--------------
#	Set this line to the location of the data file you wish to search and display
#	*This is a server path without a slash on the end.*

$datafile = "fsfprs.dat";

#	HTML Files
#	--------------
# 	This script uses templates for the header of the page, 
#	the footer of the page, and a search form. Note the Usage of the 
#	example files provided. These are SECTIONS of a page...
#	not the whole page...hint hint.
#



#	HTML Files Required
#	-------------------
# 	These files must exist, even if empty. They must be in the same directory as the script unless you care to add paths.
#	
#	display_header.dat 
#	-html for the top of the web page created. Starts with <html> and has a full head.
#
#	display_footer.dat
#	-html for the bottom of the page. Ends with </html> DOES NOT INCLUDE THE <HTML> tag.
#
#	search_form.dat
#	-this is a custom little search form. Starts and ends with a form tag...completely
#	 self contained. More on how to set this up below.
#	
#	Search Terms
#	-------------------
#
#	This is my little concept. Lets see if I can explain. The search works on
#	a whittling down process. It starts with the whole file as a result, and the performs
#	a progreesive amount of searches against each result.
#	
#	The results from the first search term are used in the next search. Thats
#	how it whittles down the results.
#	
#	Number one the keyword filed in your search MUST be named searchtext. That is
#	what the script is looking for.
#	
#	After that you may have as many different search terms as you like, and you will
#	set them in the array (an @ variable) below. On the Search form itself you will make 
#	a field with the matching name listed here. Leave the first option with a value
#	of nothing if you want people to be able to ignore the field. (<option value=""></option>)
#	
#	So what this allows is a search on any number of terms the user decides on. In the case of an
#	address book this may mean the search for a city, or a state, or both by choosing 
#	something form each list. The best way to do this is to use drop down lists. 
#	This will allow you to TELL THE USER WHAT TO LOOK FOR. This is the important 
#	part of the concept. By telling them what they can look for, you help them find results.
#	
#	
#	Syntax is important here...you are setting a perl variable. A long list would look like this...
#	@searchterms = ("city","state","zip");
#	
#	remember that the search term must match the field name in the form for it to be checked.

@searchterms = ("State");

#	
#	Repeat the same table fields set in the database doctor script here


@table_fields = ("First-Name","Last-Name","Business-Name","State","Email","Web-Site","Comment");

#	
#	The number of results you would like to have on a page. Next page links are made automatically.


$limit_of_search_results = 20;

#	Searching with Links (Get)
#	--------------------------
#	
#	If you want to create links to search your data file, you can do that with this release.
#     Each link would contstructed like this:
#
#	...display.cgi?search=1&searchtext=fred
#
#     You can also add the searchterms in here as well. Just remember to separate each group 
#	with an & , and have a key and a value separated with an = sign.
#
#	So, the same string above with a searchterm added...
#
#	...display.cgi?search=1&searchtext=fred&State=FL
#
#	Spaces in direct links
#	--------------------------
#	
#	Be aware that spaces in direct links may not work on some browsers.



#	Revolving Color Option
#	----------------------
#	
#	If you want a Table of results to use rotating colors, set the hex color values here.


$bgcolor1 = "#F8F1F1";
$bgcolor2 = "#ffffff";

#	
#	The next Four parts are the html for the search results. This is set to use tables, but
#	you could easily not use them. Have fun...this is VERY flexible with a little imagination.
#	
#	A note about print qq! statements.
#	----------------------------------
#	
#	we use the print qq! statement to print large blocks of html here. 
#	This changes the rules a little..for the better.
#	
#	-you do not need to precede a quotation (") with a slash as you would in a normal print satement.
#	-you still need to precede the @ sign not used as a variable...like an email address...like this \@
#	-in a print qq! you need to precede the exclamation point with a slash, 
#	 as it is looking for that as the end of the print statement.... use \!
#	
#	Table Header or Top of Display
#	------------------------------
#	
#	really basic here...just html
#	


sub table_header
{
print qq!
<CENTER><TABLE cellspacing="" cellpadding="5" COLS=2 WIDTH="90%" border=0>
<TR BGCOLOR="#800000">
<TD WIDTH="50%"><FONT face=Arial,Helvetica" size="3" color="ffffff">Name</FONT></TD>

<TD WIDTH="50%"><FONT face=Arial,Helvetica" size="3" color="ffffff">Comment</font></TD>
</TR>
!; # end of print statement
}

#	Not So Basic...the individual search result
#	-------------------------------------------
#	
#	You have a lot of options here, and a little perl knowledge will help. However, I will try to
#	tell you everything you need to know. At the bottom is a specific example of a customization I used. 
#	Don't be afraid to try!
#	
#	The program is taking the result and splitting it up into an array. You can then display
#	whatever parts of this individual line here by using a variable.
#	
#	We have split the line into the array @field. Individual parts of the array are accessed by
#	telling it what number you want.
#	
#	VERY IMPORTANT...arrays start counting from zero!  
#	
#	So the first field in the line is $field[0], the fifth $field[4] etc...
#	
#	The variable name field is case sensitive!
#	
#	Include any html you want, and place your fields in any order. If you want to use rotating
#	rows of color, set your table row to include <TR bgcolor=$bgcolor>, and set the colors above.
#	The use of other variables is explained below. Otherwise $email and others have no value.

sub table_row
{
	$email="";$website="";$name="";
	
	if ($field[2] ne "")
	{$name="<BR>$field[2]";}
	
	if ($field[4] ne "")
	{$email="<BR>Email: <a href=\"mailto:$field[4]\">$field[0] $field[1]</a>";}
	
	if ($field[5] ne "")
	{$website="<BR>Website: <a href=\"$field[5]\">$field[5]</a>";}

print qq!
<TR bgcolor=$bgcolor>
<TD WIDTH="50%" valign=top>
<BR>$field[0] $field[1] of $field[3]
$name
$email
$website
</TD>

<TD WIDTH="50%" valign=top>
$field[6] &nbsp;</TD>
</TR>


!;
}

#	Table Footer or Bottom of Display
#	------------------------------
#	
#	really basic here...just html
#	but I would caution you that Netscape will not show incomplete tables
#	...so make sure you close it out.

sub table_footer
{
print qq!
<TR BGCOLOR="#800000">
<TD><font size="1">&nbsp;</font></TD><TD><font size="1">&nbsp;</font></TD>
</TR>
</TABLE></CENTER>


!;
}

#	Customization Example
#	------------------------------
#	
#	In my original usage for the script I have email and website addresses. 
#	Some lines have them, and some don't. I only want to show them if they exist.
#	You can do this for as many of the fields as you like.
#	So we make a little if statement...
#
#	if ($field[5] ne "")
#
#	This is using a double negative...and reads if the 4th 
#	field is not equal to nothing, then it is something and do this...
#
#	{$address2="<BR>$field[5]";}
#
#	What we do next is set the value of the field to a variable name. We then put the variable name
#	in the the table row html where we would want it if it existed. If it exists, it will show up there.
#	If it does have no value, nothing will appear.
#
#	But Perl Programmers..this leaves us open to a lttle programming problem.
#	...if one line has a value, and the next does not, we need to clear 
#	out the value of our variable beforehand. We do this by setting the value of the variable
#	we are using before we ask the if question and possible set a value.
#
#	Below is the all of this put together. Remember to take out the comments (#) if you try it out.


#	$address2="";$email="";$website="";$name="";
#	
#	
#	if ($field[5] ne "")
#	{$address2="<BR>$field[5]";}
#	
#	if ($field[3] ne "")
#	{$name="$field[3]";}
#	
#	if ($field[12] ne "")
#	{$email="<BR>Email: <a href=\"mailto:$field[12]\">$field[12]</a>";}
#	
#	if ($field[13] ne "")
#	{$website="<BR>Website: <a href=\"$field[13]\">$field[13]</a>";}


##############################################################
##############################################################
# End Of configure
##############################################################
##############################################################


##############################################################
#  Parse from the web form
##############################################################
(!$ENV{'REQUEST_METHOD'}) && (die __FILE__.' line '.__LINE__." No Request method, $!\n");
  
## If method is GET or HEAD, fetch the query from the environment.
  
	if ($ENV{'REQUEST_METHOD'} =~ /^(GET|HEAD)$/ ) {
	$query_string = $ENV{'QUERY_STRING'};

	if(!$query_string)
	{ # could just be a link into the script
	$form{1}=1;# so we have a defined value and the system will fire
	}

	}

  ## If the method is POST, fetch the query from standard input.

  	if ($ENV{'REQUEST_METHOD'} eq 'POST') {
   
 	$length = $ENV{'CONTENT_LENGTH'} if $ENV{'CONTENT_LENGTH'};

	## no content length, and something is wrong, die to prevent further problems
	(!$length) && (die __FILE__.' line '.__LINE__." No content length with with POST request, $!\n");

	## if length is to long, then someone is probably attempting to crack the system
	($length > 163840) and  (die __FILE__.' line '.__LINE__." Content Length exceeded Post hard limit of 16384, $!\n");

	## ok, this is probably ok
	while($length){
		$query_string .= getc(*STDIN);
		$length--;
	}
		
	## we failed somehow
	!$query_string && (die __FILE__.' line '.__LINE__." No standard input with POST request, $!\n");

	}

	
	## We've gotten this far, our query string is available, 
	## break it down to key/value pairs
	
	my(@pairs) = split('&',$query_string);
	my($key,$value);
	
	my(@pairs) = split('&',$query_string);
	my($key,$value);

	foreach (@pairs) {
	($key,$value) = split('=');
	$key   = &unescape($key);		# convert pairs to something usable
      !$key  and next;
	!$value and next;
	$value = &unescape($value);
	$form{$key} = $value;			# load our hash
	}




##-------------------------------------Sub unescape -----------------------##

	sub unescape {
	my($string) = @_;
	$string =~ tr/+/ /;       # pluses become spaces
	$string =~ s/%([0-9a-fA-F]{2})/pack("c",hex($1))/ge;
	return $string;
	}



print "Content-type: text/html\n\n";

##############################################################
#  Read in data and decide what to do
##############################################################



open (FILE, "display_header.dat") || die print "$html_path/display_header.dat";
while(<FILE>)
{$row = $_;chop $row;
$header .= "$row\n";}
close (FILE);

open (FILE, "display_footer.dat") || die print "display_footer.dat";
while(<FILE>)
{$row = $_;chop $row;
$footer .= "$row\n";}
close (FILE);


open (FILE, "search_form.dat") || die print "search_form.dat";
while(<FILE>)
{$row = $_;chop $row;
$search_form .= "$row\n";}
close (FILE);



	open (DATABASE, "$datafile") || die print "$datafile";
	@data=<DATABASE>;
	close (DATABASE);

	$counter = 1;

	foreach $data(@data)
	{$search_data{$counter} = $data; $counter++;}

	$counter = 0;

	foreach $table_fields(@table_fields)
	{$field_placement{$table_fields} = "$counter"; $counter++;}


##############################################################
#  Search if necessary
##############################################################
$results_counter = 1;

if ($form{'search'})
{

$search_terms_present = 0;

	# Split keywords
	#########################################
	@searchText = split(/\x20/,$form{'searchtext'});

	foreach $test (@searchText)
	{if ($test =~ /\S{2,}/){ push @searchKey, $test;}}

	# Prepare Link
	#########################################
	$search_query = "search=1";

	$form{'searchtext'} and $search_query .= "&searchtext=$form{'searchtext'}" and $search_terms_present++;

	foreach $searchterms(@searchterms)
	{$form{$searchterms} ne "" and $search_query .= "&$searchterms=$form{$searchterms}" and $search_terms_present++;}
	

	# Loop Through Data
	#########################################
	foreach $key(keys %search_data)
	{

	$found = 0;

	@line = split (/\|/, $search_data{$key});

	# For those of you keeping score here...@line is the array we split, 
	# $key is a number which relates to the original data hash
	# %field_placement relates to the position of the field we are searching for



	# Custom Searching
	#########################################
	foreach $searchterms(@searchterms)
	{$form{$searchterms} and $line[$field_placement{$searchterms}] =~ /\b$form{$searchterms}\b/i and $found++;}

	# Text Searching
	#########################################

	if ($form{'searchtext'})
	{

	foreach $test(@searchKey)
      {$search_data{$key} =~ /\b$test\b/i and $found++;}

	} # end if we have search text

	# Check Results
	#########################################
	# if we find something we make a new hash relation ship called %search_results

	$found > 0 and $found == $search_terms_present and do{
	$search_results{$key} = $search_data{$key}; 
	$result_map{$results_counter} = $key; 
	$results_counter++;
	}; #end found do

	} #end foreach search key



} # end search routines
##############################################################
#  Begin the page of results
##############################################################
print "$header";

$starting_point = $form{'starting_point'};
!$starting_point and $starting_point = 1;

$current_page_number = int($form{'starting_point'}/$limit_of_search_results) +1;
$end_point = ($current_page_number * $limit_of_search_results);

if (%search_results)
{
&table_header;
$result = $starting_point;
	for $result($starting_point..$end_point)
	{

	!$search_results{$result_map{$result}} and next;

	$last_displayed = $result;

	@field = split (/\|/, $search_results{$result_map{$result}});


	if ($bgcount > 1)
	{$bgcolor=$bgcolor2;$bgcount=1;}
	else
	{$bgcolor=$bgcolor1;$bgcount=2;}

	&table_row;
	}

&table_footer;
}
else
{
print "<P><ul><ul>Sorry, nothing has matched what you are searching for. Please try again.</ul></ul><P>";
}

	$results_counter--;

	$results_counter > $limit_of_search_results and do{


	$page_count = int($results_counter/$limit_of_search_results) +1;

	($results_counter/$limit_of_search_results) == int($results_counter/$limit_of_search_results) and $page_count--;
	
	$next_starting_point = ($last_displayed + 1);

	$count =1;
	$starting_point = 1;

	until ($count > $page_count)
	{
	$count == $current_page_number and $next_results_link .= qq~<b>$count</b> | ~;
	$count != $current_page_number and $next_results_link .= qq~<a href="display.cgi?$search_query&starting_point=$starting_point">$count</a> | ~;

	$starting_point += $limit_of_search_results;
	$count++;
	}

	$next_starting_point > $results_counter and $next_starting_point = 1;

	$next_results_link .= qq~<a href="display.cgi?$search_query&starting_point=$next_starting_point">Next Page</a>~;

	print "<P><center>$next_results_link</center><P>";

	};#end do


print "<P>$search_form<P>";
print "<P>$footer<P>";



